//******************************************************************************
// "WARCRAFT" by Georgy Moshkin
// -----------------------------------------------
// email  : tmtlib@narod.ru
// WWW    : http://www.tmtlib.narod.ru/
//
// License:
// --------
// This unit is freely distributable without licensing fees and is
// provided without guarantee or warrantee expressed or implied. This unit
// is Public Domain. Feel free to use or enhance this code. You can use the
// program for any purpose you see fit.
//
//******************************************************************************
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls,
  _strman, //    (  StringWordGet)
  _vec2d,  //    
  OpenGL;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Timer1: TTimer;
    ListBox1: TListBox;
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    Timer2: TTimer;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;

    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TimerDraw(Sender: TObject);
    procedure Panel3Cursor(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Panel3Click(Sender: TObject);
    procedure ShowInfo(Sender: TObject);
  private
    { Private declarations }
    rc : HGLRC;    // RC
    dc  : HDC;     // DC

    procedure InitGL;
    procedure glDraw;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

var MyMouse:TPOINT;

// ---   ---

const lw=25; //      (x)
const lh=25; //      (y)

const dx=50; //   ( )

// ---   ---

const speed=1; //   

// ---   ---

var movex,movey:single; //    x   y (   )

// -- :   RGB ---

type TRGB=record
           r:single; // 
           g:single; // 
           b:single; // 
          end;

// -- :  ---

type TRassa=record
             color:TRGB;     //     
             zoloto:integer; //      
            end;

// --- :  --

type Tigrok=record
            pos:tvector2;       //   () - x,y
            power:single;       //   
            maxpower:single;    //   
            misl:string;        // 
            futuremisl:string;  //   
            plan:integer;       //   ,
                                //     (  )
                                //    plan = -777      planmax
            planmax:integer;    //   (  )
            rassaNomer:integer; //   (    rassa: rassa[rassaNomer].[...])
            tip:integer;        // tip = -1 
                                // tip = -5 
                                // tip = 0,1,2,3,4,5  . - 
            zoloto:integer;     //    
           end;
           
// --- ,    ---
const igrnum=300;               //  


// ---    () ---
var igrok:array[0..igrnum-1] of Tigrok; //   
                                        // .
                                        //     
                                        // ,   .
                                        //    ,  
                                        // .

// -- ,    --
const rassinum=3; //   

// -- ,       (, ) ---
var rassa:array[0..rassinum-1] of TRassa;

// --   (   igrok)
var vibranigrok:integer=-1; // ,  igrok[vibranigrok]. ...

// --     (x,y)    
var MouseCache:TPOINT;

// ---     ---
procedure NewBase(i:integer); // i -    igrok[i],   
begin
    igrok[i].power:=200;
    igrok[i].maxpower:=200;
    igrok[i].zoloto:=0;
    igrok[i].rassaNomer:=1;
    igrok[i].tip:=0;        //  0 = 
    igrok[i].misl:='';
end;

// ---     ---
procedure NewKrest(i:integer); // i -        IGROK
begin
    igrok[i].power:=100;    // 
    igrok[i].maxpower:=100; // .
    igrok[i].zoloto:=0;     //   
    igrok[i].tip:=-1;       //  -1 = 
    igrok[i].rassaNomer:=1; //  
end;

//  -    C1  C2
function Rasst(c1,c2:TVector2):single; // c1,c2 - 
var e:TVector2;
begin
 e.x:=(c1.x-c2.x);
 e.y:=(c1.y-c2.y);
 result:=sqrt(e.x*e.x+e.y*e.y); //    c1-c2
end;


// --- AI -    ---
//       komp.
//     - 
procedure INTELLEKT(komp:integer); // komp -  ,    rassa[komp]. ...
var i,j:integer; //  
    k,l:integer; //   
    rst:single;  //    
    s:string;    //  
    s1,s2:string;  //  

    krestNum:integer;   //  
    krestLuboy:integer; //     (   )
    krestSvob:integer;  //    (misl='idle');

    bazaNum:integer;    //  
    bazaLubaya:integer; //    ()
    bazaSvob:integer;   //   


    stroyka:boolean;    //    

begin

krestNum:=0;    //  0 =     
krestLuboy:=-1; // -1 =     (  -     )
krestSvob:=-1;  // -1 =    

bazaNum:=0;     //  
bazaLubaya:=-1;
bazaSvob:=-1;

stroyka:=false; //    (  )

//     :   ,
//    (   ).
//    ר  

 for i:=0 to igrnum-1 do //    
  if ((igrok[i].power>0) and (igrok[i].rassaNomer=komp)) then //      = komp, 
   begin

     if igrok[i].misl='' then igrok[i].misl:='idle'; // ''  'idle' .   ''  'idle'  .

     //   :
     //     ? (   "stroit 0" -    )
     s:=StringWordGet(igrok[i].misl,',',1); //     (  )
     if ((igrok[i].tip=-1) and (s='stroit 0')) then stroyka:=true //    ( 0)
                                                else stroyka:=false; //   

     //   :
     case igrok[i].tip of
      -1: inc(krestNum);  //  
       0: inc(bazaNum);   //  
      -5: igrok[i].misl:='idle'; //  .    
     end;

     //  krestLuboy=-1,      .
     //    :
     if (igrok[i].tip=-1) and (krestLuboy=-1) then krestLuboy:=i;

     //      :
     if (igrok[i].tip=0) and (bazaLubaya=-1) then bazaLubaya:=i;

     //   ,    misl='idle':
     if (igrok[i].tip=-1) and (igrok[i].misl='idle') and (krestSvob=-1) then krestSvob:=i; //    
     if (igrok[i].tip=0) and (igrok[i].misl='idle') and (bazaSvob=-1) then bazaSvob:=i;  //    

     //       :
     // )    (misl=idle),   
     // )  ,    

     //  ):
     // ---------
     if igrok[i].misl='idle' then igrok[i].plan:=0;

     //  ):
     // ----------
     //    StringWordGet   
        s1:=StringWordGet(igrok[i].misl,' ',1); //   
        s2:=StringWordGet(igrok[i].misl,' ',2); //    
     //  S1  S2

     //  S1   ""
     // (-) IF (='') then
     // (--) IF     (power<=0) THEN
{-}     if (s1='idetiza') then
{--}     if igrok[StrToInt(s2)].power<=0 then
         begin
          igrok[i].futuremisl:='idle'; //   ( )
          igrok[i].zoloto:=1; //     ( )
          if bazaLubaya<>-1 then igrok[i].misl:='idtiza '+inttostr(bazaLubaya); //   ,     ( )
         end;

     //     (  ),
     //     :
     if (s1='atakovat') then                 //  = 
       if igrok[StrToInt(s2)].power<=0 then  //    
        begin
         igrok[i].futuremisl:='idle';
         igrok[i].zoloto:=1; //    
         if bazaLubaya<>-1 then  igrok[i].misl:='idtiza '+inttostr(bazaLubaya); //    (IDTIZA )
        end;

   end; // --- --- ---

 // ,   :
 // ----------------------
 // krestNum   -   
 // bazaNum    -   
 // krestLuboy -    
 // bazaLubaya -    
 // krestSvob  -   
 // bazaSvob   -   
 // -----------------------
 //       

 // !!!!!!!!!!!!!!!!!!!!!!!!!!
 //   
 // !!!!!!!!!!!!!!!!!!!!!!!!!!
 // 1)    = 0  Ĩ(storyka=false),
 // 1)     (100$),   . =)
 if ((bazaNum=0) and (stroyka=false))
    or ((rassa[komp].zoloto>=150) and (stroyka=false)) then //   :
  begin
  //    ,    .
  //      ,   
  //       
  // ..   :

   l:=-1; //    

   if krestSvob<>-1 then  //   
    begin
     l:=krestSvob;
     krestSvob:=-1; //   
    end
   else
    if krestLuboy<>-1 then //    -  
     begin
      l:=krestLuboy;
      krestLuboy:=-1; //   
     end;

   if l<>-1 then //    , 
    begin
    //       
     igrok[l].plan:=0;      //     (   )
     igrok[l].planmax:=100; //      = 100
     igrok[l].misl:='stroit '+IntToStr(0)+','+IntToStr(round(igrok[l].pos.x-dx/2+dx))+','+IntToStr(round(igrok[l].pos.y-dx/2+dx));
    end
  end;

// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//      
//       "idle" ()
//  -
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
if random(100)=7 then //     0  99   7, 
 if rassa[komp].zoloto<>0 then //    
 begin
  k:=-1; //   (   , 
  l:=-1; //                    -  ).

    //   K  rassaNomer
    for i:=0 to igrnum-1 do //    
     if random(10)=5 then   //    , 
     begin
       //      K.  -  ,   rassaNomer<>komp
       if ((igrok[i].power>0) and (igrok[i].rassaNomer<>komp) and (igrok[i].tip<>-5)) then k:=i;
       if ((igrok[i].power>0) and (igrok[i].rassaNomer<>komp) and (igrok[i].tip<>-5)) then break;
       // rassaNomer -   i- 
       // komp -  ,    
     end;

    if krestSvob=-1 then //    
     begin
       //    L  
       for i:=0 to igrnum-1 do
        begin
          if ((igrok[i].power>0) and (igrok[i].rassaNomer=komp) and (igrok[i].tip=-1) and (igrok[i].misl='idle')) then l:=i;
          if ((igrok[i].power>0) and (igrok[i].rassaNomer=komp) and (igrok[i].tip=-1) and (igrok[i].misl='idle')) then break;
        end;
     end
      else
     begin //   
      l:=krestSvob;
      krestSvob:=-1; //  
     end;

   //   K -  ,   L -    

   //  K  L <> 1,      igrok[k]    igrok[l] 
  if (k<>-1) and (l<>-1) then
   begin
   igrok[l].misl:='idtiza '+intToStr(k); //    L    K ( )
   igrok[l].plan:=-777;                  //   -777 -   ( ,  -777)
   end;


 end;

 // --------------------------
 //   
 //   ,  :
 //    ,      (=0)
 // -----------------------------------------------

 if (random(100+krestnum*10)=7) or (krestnum=0)  then
  begin
     //      , 
     if bazaSvob<>-1 then
      begin
       //      
       igrok[bazaSvob].plan:=0;
       igrok[bazaSvob].planmax:=10;
       igrok[bazaSvob].misl:='stroit '+IntToStr(1)+','+IntToStr(round(igrok[bazaSvob].pos.x-dx/2))+','+IntToStr(round(igrok[bazaSvob].pos.y-dx/2));
       bazaSvob:=-1; //       
      end;
 end;

 // --------------------------
 //  
 //  
 // -----------------------------

if random(10)=7 then //   
 if (rassa[komp].zoloto<1) then //   , 
  if krestSvob<>-1 then //    , 
  begin

   //   L
    rst:=100000;
    for i:=0 to igrnum-1 do
       if ((igrok[i].power>0) and (igrok[i].tip=-5) and (Rasst(igrok[i].pos,igrok[krestSvob].pos)<rst)) then
       begin
        l:=i;
        rst:=rasst(igrok[i].pos,igrok[krestSvob].pos);
       end;

  //       :
  igrok[krestSvob].misl:='idtiza '+intToStr(l); //  krestSvob    l


  end;



end;


//       3d .
//  CENTURUS -   
//      "", "" 
//   BOOLEAN:     
// center1,2 -   
// radius1,2 -  
// tip1,2 -  
//       Centurus(           ;               ;    )
function Centurus(var center1,center2:TVector2;radius1,radius2:single;tip1,tip2:integer):boolean;
var c1,c2,e,napr:TVector2; //  
    dlina,movi:single;     //
begin

c1.x:=center1.x; //    
c1.y:=center1.y;

c2.x:=center2.x; //     
c2.y:=center2.y;

e.x:=(c1.x-c2.x); //  ,   C1  C2
e.y:=(c1.y-c2.y);

dlina:=sqrt(e.x*e.x+e.y*e.y); //    (  C1  2)

napr:=normaliz2(e); //    

if dlina<radius1+radius2 then //      , 
 begin

  movi:=radius1+radius2-dlina; //       

  c1.x:=c1.x+napr.x*movi/2; //       MOVI
  c1.y:=c1.y+napr.y*movi/2;

  c2.x:=c2.x-napr.x*movi/2; //    -    ( )
  c2.y:=c2.y-napr.y*movi/2;

  result:=true; //   (true)

 end else result:=false; //   (false)

 //   
 if tip1=-1 then begin //   = -1 (),  
  center1.x:=c1.x;
  center1.y:=c1.y;
  end;

 //   
 if tip2=-1 then begin //   = -1 (),  
  center2.x:=c2.x;
  center2.y:=c2.y;
  end;

end;


procedure TForm1.glDraw(); //     OPENGL 
var i,j,k:integer; // 
s1,s2:string;      // 
l1,l2,l3:integer;  //
begin


 glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT); //  
 glLoadIdentity(); //    

 //  AI   Ш :
if checkbox1.Checked then  INTELLEKT(0);
if checkbox2.Checked then  INTELLEKT(1);
if checkbox3.Checked then  INTELLEKT(2);

//      ,   
 if MyMouse.x<dx*2 then movex:=movex+1;
 if MyMouse.y<dx*2 then movey:=movey+1;
 if MyMouse.x>panel3.Width-dx*2 then movex:=movex-1;
 if MyMouse.y>panel3.Height-dx*2 then movey:=movey-1;

//     
 glDisable(GL_TEXTURE_2D);
 glDisable(GL_DEPTH_TEST);

//     
 glBegin(GL_TRIANGLES);
 glVertex3f(MyMouse.x-5,MyMouse.y-5,0);
 glVertex3f(MyMouse.x,MyMouse.y,0);
 glVertex3f(MyMouse.x+5,MyMouse.y-5,0);
 glEnd;

//     
 glTranslatef(movex,movey,0);
 glColor3f(0.3,0.3,0.3);

//    
 for i:=0 to lw-1 do
  for j:=0 to lh-1 do
   begin
    glBegin(GL_LINE_LOOP);
    glVertex3f(i*dx,j*dx,0);
    glVertex3f(i*dx+dx,j*dx,0);
    glVertex3f(i*dx+dx,j*dx+dx,0);
    glVertex3f(i*dx,j*dx+dx,0);
    glEnd;
   end;

    glColor3f(0.7,0.7,0.7);

    //   ,   DX
    i:=trunc((MyMouse.x-moveX)/dx);
    j:=trunc((MyMouse.y-moveY)/dx);
    MouseCache.X:=i{*dx};
    MouseCache.Y:=j{*dx};

    //     .   glColor3f(0.7,0.7,0.7);
    glBegin(GL_LINE_LOOP);
    glVertex3f(i*dx,j*dx,0);
    glVertex3f(i*dx+dx,j*dx,0);
    glVertex3f(i*dx+dx,j*dx+dx,0);
    glVertex3f(i*dx,j*dx+dx,0);
    glEnd;

 //    . ,  
 // igrok    ,     ()
 for i:=0 to igrnum-1 do with igrok[i] do
  begin

   if power>0 then //   (,   ), 
    begin

    case tip of //    
     -1: begin //  
         glPointSize(10);
         glBegin(GL_POINTS);
          with rassa[rassaNomer] do
          glColor3f(color.r,color.g,color.b);
          glVertex3f(pos.x,pos.y,0);
         glEnd;

         // :
         glBegin(GL_LINES);
         glVertex3f(pos.x-dx/24,pos.y,0);
         glVertex3f(pos.x-dx/24+5*sin(gettickcount/50+i*11.765),pos.y-dx/3,0);
         glVertex3f(pos.x+dx/24,pos.y,0);
         glVertex3f(pos.x+dx/24+5*cos(gettickcount/50+i*11.765),pos.y-dx/3,0);
         glVertex3f(pos.x,pos.y,0);
         glVertex3f(pos.x-dx/4,pos.y,0);
         glEnd;

         if zoloto>0 then //    
          begin
           glPointSize(3);
           glBegin(GL_POINTS);
           glColor3f(1,1,0);
           glVertex3f(pos.x,pos.y+dx/3,0);
           glEnd;
          end;
         end;
     0,1,2,3,4:begin  //   (, ...)
                glBegin(GL_LINE_LOOP);
                 with rassa[rassaNomer] do
                glColor3f(color.r,color.g,color.b);
                glVertex3f(pos.x-dx/6,pos.y-dx/6-dx/4,0);
                glVertex3f(pos.x-dx/6,pos.y+dx/6-dx/3,0);
                glVertex3f(pos.x     ,pos.y+dx/6-dx/6,0);
                glVertex3f(pos.x+dx/6,pos.y+dx/6-dx/3,0);
                glVertex3f(pos.x+dx/6,pos.y-dx/6-dx/4,0);
                glEnd;

                glBegin(GL_LINES);
                glVertex3f(pos.x-dx/6,pos.y+dx/6-dx/3,0);
                glVertex3f(pos.x+dx/6,pos.y+dx/6-dx/3,0);
                glEnd;
               end;

      -5:begin   //  
                glBegin(GL_LINE_LOOP);
                glColor3f(1,1,0);
                glVertex3f(pos.x-dx/6,pos.y-dx/6,0);
                glVertex3f(pos.x-dx/6,pos.y+dx/6,0);
                glVertex3f(pos.x+dx/6,pos.y+dx/6,0);
                glVertex3f(pos.x+dx/6,pos.y-dx/6,0);
                glEnd;
               end;
       end;



     glBegin(GL_LINES); //    (power)
      glColor3f(1,0,0);
      glVertex3f(pos.x-dx/4,pos.y+dx/4,0);
      glColor3f(0,1,0);
      glVertex3f(pos.x-dx/4+(power/maxpower)*dx/2,pos.y+dx/4,0);
     glEnd;
    end;
  end;


  //  
  // --    --
 for i:=0 to igrnum-1 do with igrok[i] do //     
  if power>0 then //    
  begin
   s1:=StringWordGet(misl,' ',1); //    s1
   s2:=StringWordGet(misl,' ',2); //     S2

   //      , 
   if (s1='idtiza')and(igrok[i].tip=-1) then
    begin
     l1:=strtoint(s2); //     ( )
     //   ():
     if igrok[i].pos.x<igrok[l1].pos.x then igrok[i].pos.x:=igrok[i].pos.x+speed;
     if igrok[i].pos.x>igrok[l1].pos.x then igrok[i].pos.x:=igrok[i].pos.x-speed;
     if igrok[i].pos.y<igrok[l1].pos.y then igrok[i].pos.y:=igrok[i].pos.y+speed;
     if igrok[i].pos.y>igrok[l1].pos.y then igrok[i].pos.y:=igrok[i].pos.y-speed;
    end;

   //       = , 
   if (s1='idti')and (igrok[i].tip=-1) then
    begin
    //  s2    s1.   = s1+s2
    l1:=strtoint(StringWordGet(s2,',',1)); //   S2  X
    l2:=strtoint(StringWordGet(s2,',',2)); //   S2  Y
    //   s2 = strToInt(l1)+','+strToInt(l2)
    // misl = s1 + s2
    //   StringWordGet     
    //     StringWordGet   ().

    //   ():
    if igrok[i].pos.x<l1 then igrok[i].pos.x:=igrok[i].pos.x+speed;
    if igrok[i].pos.x>l1 then igrok[i].pos.x:=igrok[i].pos.x-speed;
    if igrok[i].pos.y<l2 then igrok[i].pos.y:=igrok[i].pos.y+speed;
    if igrok[i].pos.y>l2 then igrok[i].pos.y:=igrok[i].pos.y-speed;
    end;

   //   
   if s1='atakovat' then
    begin
     l1:=strtoint(s2);
     if igrok[i].tip<>-5 then //    (   )
     if rasst(igrok[i].pos,igrok[l1].pos)<dx*2 then //      
      begin
       igrok[l1].power:=igrok[l1].power-1; //   ,  
       if igrok[l1].power<0 then igrok[i].misl:=''; //    l1,     
       glBegin(GL_LINES); //    
       glColor3f(1,0,0);
       if random(10)<5 then
       begin
        with igrok[i].pos do glVertex3f(x,y,0);
        with igrok[l1].pos do glVertex3f(x,y,0);
       end;
       glEnd;
      end
       else //    -    ""
      begin
       igrok[i].misl:='idtiza '+intToStr(l1); //    (   )
      end;
    end;

   //   ""
   if s1='stroit' then
    begin
    //   
     l1:=strtoint(StringWordGet(s2,',',2)); //x
     l2:=strtoint(StringWordGet(s2,',',3)); //y
    //    
     l3:=strtoint(StringWordGet(s2,',',1)); // 

    //     (   ) 
     glBegin(GL_LINES);
      glColor3f(0,1,0);
      glVertex3f(pos.x-dx/4,pos.y+dx/3,0);
      glColor3f(0,1,0);
      glVertex3f(pos.x-dx/4+(plan/planmax)*dx/2,pos.y+dx/3,0);
     glEnd;

     //   , 
     if rassa[igrok[i].rassaNomer].zoloto>0 then
      begin  //  ,  
             dec(rassa[igrok[i].rassaNomer].zoloto); //  
             with igrok[i] do inc(plan); //   
             if plan>=planmax then //  , 
              begin
              plan:=0; //  
               j:=-1;
               repeat
                j:=j+1; //       
               until igrok[j].power<=0; //    (power<=0)

               //       -1 (    +1)
               if l3=1 then l3:=-1; // 1 = -1
               //      ,    
               //   

               //    ,  
               case l3 of
                0: begin //  
                    NewBase(j); //   
                    igrok[j].rassaNomer:=igrok[i].rassaNomer; //      ,    
                    igrok[j].pos.x:=l1+dx/2;//igrok[i].pos.x;
                    igrok[j].pos.y:=l2+dx/2;//igrok[i].pos.y;
                    igrok[i].misl:='idle' //   
                   end;
                -1: begin //  
                    NewKrest(j);
//                    igrok[j]:=igrok[3];
                    igrok[j].rassaNomer:=igrok[i].rassaNomer;
                    igrok[j].pos.x:=l1+dx/2;//igrok[i].pos.x;
                    igrok[j].pos.y:=l2+dx/2;//igrok[i].pos.y;
                    igrok[j].misl:='idle'; //   
                    igrok[i].misl:=''; //   
//                    ShowMessage(igrok[j].misl);                    
                   end;
               end;


              end;

       end; //      begin   end-


    end;

   // 
   if s1='chinit' then
    begin
     //    .      
     //      -   
     // .
    end;

  end;

  //   (   ).
  for i:=0 to igrnum-1 do
   for j:=i+1 to igrnum-1 do
    if rasst(igrok[i].pos,igrok[j].pos)<dx*2 then
     if (igrok[i].power>0) and (igrok[j].power>0) then
      if igrok[i].rassaNomer<>igrok[j].rassaNomer then
      begin
       if igrok[i].tip<>-5 then igrok[j].misl:='atakovat '+inttostr(i);
       if igrok[j].tip<>-5 then igrok[i].misl:='atakovat '+inttostr(j);
      end;


  //  
  for i:=0 to igrnum-1 do   //    
   for j:=i+1 to igrnum-1 do
    if (igrok[i].power>0) and (igrok[j].power>0) then
     if Centurus(igrok[i].pos,igrok[j].pos,dx/2,dx/2,igrok[i].tip,igrok[j].tip) then
      begin
             //  "", 
              if igrok[i].rassaNomer=igrok[j].rassaNomer then
              begin
             // A ---      / 
               if ((igrok[i].tip=0) and (igrok[j].zoloto>0)) then
                begin
//                 inc(igrok[i].zoloto,igrok[j].zoloto);
//                 igrok[j].zoloto:=0;

                 //  ,    
                 if igrok[i].power<igrok[i].maxpower then
                  begin
                   igrok[i].power:=igrok[i].power+igrok[j].zoloto*2;
                   if igrok[i].power>igrok[i].maxpower then igrok[i].power:=igrok[i].maxpower;
                   igrok[j].zoloto:=0;
                  end;

                 //     - "Ĩ" :) 
                 inc(rassa[igrok[i].rassaNomer].zoloto,igrok[j].zoloto);
                 igrok[j].zoloto:=0;
                 igrok[j].misl:=igrok[j].futuremisl;
                end;
               if ((igrok[j].tip=0 )and (igrok[i].zoloto>0)) then
                begin

                 //  ,    
                 if igrok[j].power<igrok[j].maxpower then
                  begin
                   igrok[j].power:=igrok[j].power+igrok[i].zoloto*2;
                   if igrok[j].power>igrok[j].maxpower then igrok[j].power:=igrok[j].maxpower;
                   igrok[i].zoloto:=0;
                  end;

                 //     ( i  j    ).
                 inc(rassa[igrok[j].rassaNomer].zoloto,igrok[i].zoloto);
                 igrok[i].zoloto:=0;
                 igrok[i].misl:=igrok[i].futuremisl;
                end;
             // A END
              end;
//               else
//              begin

             //  "" ( ), 
               if igrok[j].tip<>-5 then
                begin
                if igrok[i].rassaNomer<>igrok[j].rassaNomer then
               igrok[i].misl:='atakovat '+inttostr(j)
                end
               //  :
                                   else if (igrok[i].zoloto<30) and (igrok[j].zoloto>=10) then
                                    begin
                                     inc(igrok[i].zoloto,10);
                                     dec(igrok[j].zoloto,10);
                                     k:=-1;

                                     //   
                                      repeat
                                       inc(k);
                                       if k=igrnum-1 then break;
                                      until ((igrok[k].power>0) and
                                             (igrok[k].rassaNomer=igrok[i].rassaNomer) and
                                             (igrok[k].tip=0));
                                    if igrok[i].plan<>-777 then  igrok[i].misl:='idtiza '+intToStr(k); //   ,     
                                     igrok[i].futuremisl:='idtiza '+intToStr(j);

                                    end;

               if igrok[i].tip<>-5 then
               begin
               if igrok[i].rassaNomer<>igrok[j].rassaNomer then
               igrok[j].misl:='atakovat '+inttostr(i)
               end
                                   else if (igrok[j].zoloto<10) and (igrok[i].zoloto>=10) then
                                    begin
                                     inc(igrok[j].zoloto,10);
                                     dec(igrok[i].zoloto,10);
                                     k:=-1;

                                     //   

                                      repeat
                                       inc(k);
                                       if k=igrnum-1 then break;
                                      until ((igrok[k].power>0) and
                                             (igrok[k].rassaNomer=igrok[j].rassaNomer) and
                                             (igrok[k].tip=0));
                                     if igrok[j].plan<>-777 then igrok[j].misl:='idtiza '+intToStr(k);  //   ,     
                                     igrok[j].futuremisl:='idtiza '+intToStr(i);

                                    end;
//              end; ELSE BEGIN 
      end;

 SwapBuffers(DC);


end;


//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
procedure TForm1.InitGL;
begin
  glClearColor(0.0, 0.0, 0.0, 1.0); 	   // White Background
  glShadeModel(GL_SMOOTH);                 // Enables Smooth Color Shading
  glClearDepth(1.0);                       // Depth Buffer Setup
  glEnable(GL_DEPTH_TEST);                 // Enable Depth Buffer
  glDepthFunc(GL_LESS);		           // The Type Of Depth Test To Do

  glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);   //Realy Nice perspective calculations


end;

//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

procedure TForm1.FormCreate(Sender: TObject);
var i:integer;
var pfd : TPIXELFORMATDESCRIPTOR;
    pf  : Integer;
begin
  DecimalSeparator:='.';
  dc:=GetDC(Panel3.Handle);

  pfd.nSize:=sizeof(pfd);
  pfd.nVersion:=1;
  pfd.dwFlags:=PFD_DRAW_TO_WINDOW or PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or 0;
  pfd.iPixelType:=PFD_TYPE_RGBA;
  pfd.cColorBits:=32;

  pf :=ChoosePixelFormat(dc, @pfd);
  SetPixelFormat(dc, pf, @pfd);

  rc :=wglCreateContext(dc);    // RC
  wglMakeCurrent(dc,rc);        // DC

  InitGL;

  randomize;

    // 
    rassa[0].color.r:=0.5;  //
    rassa[0].color.g:=0.5;
    rassa[0].color.b:=0.5;

    rassa[1].color.r:=0.8; // 
    rassa[1].color.g:=0.5;
    rassa[1].color.b:=0.5;
//    rassa[1].zoloto:=1000;   -    

    rassa[2].color.r:=0.4; //
    rassa[2].color.g:=0.9;
    rassa[2].color.b:=0.5;

    // 
    igrok[0].power:=100;
    igrok[0].maxpower:=100;
    igrok[0].zoloto:=100000;  //  
    igrok[0].pos.x:=dx/2;
    igrok[0].pos.y:=dx/2;
    igrok[0].tip:=-5;
    igrok[0].rassaNomer:=0;

    // 
    igrok[1]:=igrok[0];
    igrok[1].pos.x:=(lw-1)*dx/2+dx/2;
    igrok[1].pos.y:=(lh-1)*dx/2+dx/2;

    //  
    igrok[2].power:=200;
    igrok[2].maxpower:=200;
    igrok[2].zoloto:=0;
    igrok[2].pos.x:=dx*5+dx/2;
    igrok[2].pos.y:=dx*5+dx/2;
    igrok[2].rassaNomer:=1;
    igrok[2].tip:=0;


             
    // 
    igrok[3].power:=100;
    igrok[3].maxpower:=100;
    igrok[3].zoloto:=0;
    igrok[3].pos.x:=dx*3+dx/2;
    igrok[3].pos.y:=dx*3+dx/2;
    igrok[3].tip:=-1;
    igrok[3].rassaNomer:=1;


    //    :
    // 
    igrok[4]:=igrok[2];
    igrok[4].rassaNomer:=0;
    igrok[4].pos.x:=(lw-1+12)*dx/2+dx/2;
    igrok[4].pos.y:=(lh-1+2)*dx/2+dx/2;

    // 
    igrok[5].power:=100;
    igrok[5].maxpower:=100;
    igrok[5].zoloto:=0;
    igrok[5].pos.x:=(lw-1+8)*dx/2+dx/2;
    igrok[5].pos.y:=(lh-1)*dx/2+dx/2;
    igrok[5].tip:=-1;
    igrok[5].rassaNomer:=0;

    //       
    //      (  )

    igrok[6]:=igrok[2];
    igrok[6].rassaNomer:=2;
    igrok[6].pos.x:=dx/2+dx*5;
    igrok[6].pos.y:=(lh-1)*dx/2+dx/2-dx*2;

    // 
    igrok[7].power:=100;
    igrok[7].maxpower:=100;
    igrok[7].zoloto:=0;
    igrok[7].pos.x:=dx/2+dx*3;
    igrok[7].pos.y:=(lh-1)*dx/2+dx/2-dx*2;
    igrok[7].tip:=-1;
    igrok[7].rassaNomer:=2;

    // 
    igrok[8]:=igrok[0];
    igrok[8].pos.x:=dx/2;
    igrok[8].pos.y:=(lh-1)*dx/2+dx/2;

//        igrok[2].power:=0;    

end;

//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

procedure TForm1.FormResize(Sender: TObject);
begin
  glViewport(0, 0, Panel3.Width, Panel3.Height);

(*
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(45.0, Panel3.Width/Panel3.Height, 0.1, 500.0);

  glMatrixMode(GL_MODELVIEW);
  *)

  glMatrixMode(GL_PROJECTION);  // Switch to the projection matrix
  glPushMatrix();               // Save current projection matrix
  glLoadIdentity();

  glOrtho(0, Panel3.Width, 0, Panel3.Height , -100, 100);

  glMatrixMode(GL_MODELVIEW);  // Return to the modelview matrix
  glPushMatrix();              // Save the current modelview matrix
  glLoadIdentity();


  glDraw();
end;

//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

procedure TForm1.FormDestroy(Sender: TObject);
begin
  wglMakeCurrent(0,0);
  wglDeleteContext(rc);
end;

procedure TForm1.TimerDraw(Sender: TObject);
begin
glDraw();
end;

procedure TForm1.Panel3Cursor(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
MyMouse.X:=X;
MyMouse.Y:=Panel3.Height-Y;
end;

procedure TForm1.Panel3Click(Sender: TObject);
var i,j:integer;
    xx,yy:integer;
    selected:integer;
begin

//     ()
selected:=-1;
 for i:=0 to igrnum-1 do with igrok[i] do
  begin
    xx:={dx*}trunc(pos.x/dx);
    yy:={dx*}trunc(pos.y/dx);
    if (MouseCache.x=xx) and (MouseCache.y=yy) then selected:=i;
    if (MouseCache.x=xx) and (MouseCache.y=yy) then break;
  end;

//   

 case RadioGroup1.ItemIndex of
  0: vibranigrok:=selected;
  1: if (vibranigrok<>-1) then begin
      if selected<>-1 then igrok[vibranigrok].misl:='idtiza '+inttostr(selected);
      if selected=-1 then igrok[vibranigrok].misl:='idti '+IntToStr(MouseCache.x*dx+dx div 2)+','+IntToStr(MouseCache.y*dx+dx div 2);
     end;
  2:  if (vibranigrok<>-1) then if selected<>-1 then igrok[vibranigrok].misl:='atakovat '+inttostr(selected);
  3:  if (vibranigrok<>-1) then
       begin
        if selected=-1 then igrok[vibranigrok].misl:='stroit '+IntToStr(RadioGroup2.ItemIndex)+','+IntToStr(MouseCache.x*dx)+','+IntToStr(MouseCache.y*dx);
        igrok[vibranigrok].plan:=0;
        case RadioGroup2.ItemIndex of
         0:igrok[vibranigrok].planmax:=100;  //   
         1:igrok[vibranigrok].planmax:=10;
        end;
       end;
  4:  if (vibranigrok<>-1) then if selected<>-1 then igrok[vibranigrok].misl:='chinit '+IntToStr(selected);
 end;




end;


procedure TForm1.ShowInfo(Sender: TObject);
var i:integer;
begin

listbox1.Items.Clear;
listbox1.Items.add(' : '+IntToStr(vibranigrok));
if vibranigrok<>-1 then
 begin
listbox1.Items.Add(' : '+igrok[vibranigrok].misl);
listbox1.Items.Add('  : '+igrok[vibranigrok].futuremisl);
listbox1.Items.Add(' : '+IntToStr(igrok[vibranigrok].tip));
listbox1.Items.Add(' : '+IntToStr(round(igrok[vibranigrok].power)));
listbox1.Items.Add(' : '+IntToStr(igrok[vibranigrok].zoloto));
listbox1.Items.Add(' : '+IntToStr(igrok[vibranigrok].rassaNomer+1));
listbox1.Items.Add(' :'+IntToStr(igrok[vibranigrok].plan));
listbox1.Items.Add(' :'+IntToStr(igrok[vibranigrok].planmax));
 end;

listbox1.Items.Add('-------');
for i:=0 to rassinum-1 do
listbox1.Items.Add('  N'+IntToStr(i+1)+': $'+IntToStr(rassa[i].zoloto));


end;

end.

